// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

#pragma once

#include <frc2/command/CommandBase.h>
#include <frc2/command/CommandHelper.h>
#include <units/time.h>

#include "subsystems/Chassis.h"
#include "subsystems/Shooter.h"
#include "subsystems/Gatherer.h"

/**
 * An example command.
 *
 * <p>Note that this extends CommandHelper, rather extending CommandBase
 * directly; this is crucially important, or else the decorator functions in
 * Command will *not* work!
 */
class Auto
    : public frc2::CommandHelper<frc2::CommandBase, Auto> {
 public:
  Auto(Chassis &chassis, Shooter &shooter, Gatherer &gatherer);

  void Initialize() override;

  void Execute() override;

  void End(bool interrupted) override;

  bool IsFinished() override;

 private:
  Chassis &m_chassis;
  Shooter &m_shooter;
  Gatherer &m_gatherer;

  units::second_t m_start_time;
};
